﻿@page
@model BeamAndGo.Member.Web.Pages.AddressManagementModel
@{
    ViewData["Title"] = "Address Management";
    if (Model.IsXHR) Layout = null;
    else Layout = "_Layout";

}

<style>
    .country-select {
        width: 100% !important;
    }
</style>

<div class="@(!Model.IsXHR ? "uk-container" : "")">
    <div class="uk-margin-small">
        <h3>Address Management</h3>
        <div class="uk-margin">
            @await foreach (var address in Model.MemberAddresses)
            {
                <div class="uk-margin-small @(address.IsDefault ? "uk-text-bold" : "")">
                    <div class="uk-card uk-card-default uk-card-small uk-card-body uk-width-1-1">
                        <div uk-grid>
                            <div class=" uk-width-expand@s">
                                <p class="uk-form-label uk-margin-remove">@address.Name</p>
                                <p class="uk-form-label uk-margin-remove">@address.Street</p>
                                <p class="uk-form-label uk-margin-remove">@address.CountryCode @address.PostalCode</p>
                            </div>
                            <div class="uk-width-auto@s uk-margin-remove">
                                <p class="uk-margin-remove uk-text-left@s uk-text-right@m">
                                    @if (address.IsDefault)
                                    {
                                        <span class="uk-badge uk-label uk-label-success">Primary</span>
                                    }
                                    @if (Model.KYCEnabled)
                                    {
                                        @if (address.IsVerified)
                                        {
                                            <span class="uk-badge uk-label uk-label-success">Verified</span>
                                        }
                                        else
                                        {
                                            <span class="uk-badge uk-label uk-label-warning">Unverified</span>
                                        }
                                    }
                                </p>
                            </div>
                        </div>
                        <div class="uk-margin-medium-top uk-align-right uk-flex-inline">

                            @if (!address.IsDefault)
                            {
                                @if (!address.IsVerified)
                                {
                                    <form asp-page-handler="MakePrimaryAddress"
                                          method="post"
                                          asp-antiforgery="true"
                                          asp-route-addressSid="@address.Sid"
                                          data-ajax="true"
                                          data-ajax-method="post"
                                          data-ajax-success="makePrimaryAddressSuccess"
                                          data-ajax-failure="makePrimaryAddressFailed">
                                        <button class="member-address-make-primary uk-button uk-button-small uk-text-nowrap"
                                                style="padding:5px 10px;"
                                                type="submit"
                                                memberAddressSid="@address.Sid">
                                            <i class="fas fa-star uk-margin-small-right"></i>Make Primary
                                        </button>
                                    </form>
                                }

                                <div class="uk-margin-small-left">
                                    <button class="member-address-remove uk-button uk-button-small"
                                            style="padding:5px 10px;"
                                            uk-toggle="target: #modal-address-remove"
                                            memberAddressSid="@address.Sid"
                                            memberAddress="@address.Name <br /> @address.Street <br /> @address.CountryCode @address.PostalCode <br />">
                                        <i class="fas fa-trash"></i>
                                    </button>
                                </div>
                            }
                        </div>
                    </div>
                </div>
            }
        </div>
        <div class="uk-align-right">
            <a class="uk-button uk-button-primary" uk-toggle="target: #modal-address-add">Add New Address</a>
        </div>
    </div>
</div>
<!-- This is the modal for ResendAddress -->
<div id="modal-address-resend-verification" uk-modal>
    <div class="uk-modal-dialog uk-modal-body uk-text-center">
        <p>A verification email has been sent to your e-mail address. Please follow the instructions in your email to verify your e-mail address</p>
        <form class="uk-margin" method="post" asp-page-handler="ResendAddress" asp-antiforgery="true">
            <input asp-for="@Model.MemberAddressSid" class="member-address-resend-verification-input" type="hidden">
            <button class="uk-button uk-button-primary" type="submit">Ok</button>
        </form>
    </div>
</div>
<!-- End of modal -->
<!-- This is the modal for RemoveAddress -->
<div id="modal-address-remove" uk-modal>
    <div class="uk-modal-dialog uk-modal-body uk-text-center">
        <p class="uk-margin-remove"> Are you sure you want to remove this Address? </p>
        <p class="uk-margin-remove modal-address"></p>
        <form class="uk-margin" method="post" asp-page-handler="RemoveAddress" asp-antiforgery="true" data-ajax="true" data-ajax-method="post" data-ajax-success="removeAddressSuccess" data-ajax-failure="removeAddressFailed">
            <input asp-for="@Model.MemberAddressSid" class="member-address-remove-input" type="hidden">
            <button class="uk-button uk-button-primary" type="submit">Yes</button>
            @if (Model.IsXHR)
            {
                <a class="uk-button uk-button-default" href="#bng-modal" uk-toggle>No</a>
            }
            else
            {
                <button class="uk-button uk-button-default uk-modal-close" type="button">No</button>
            }
        </form>
    </div>
</div>
<!-- End of modal -->
<!-- This is the modal for AddAddress -->
<div id="modal-address-add" uk-modal>
    <div class="uk-modal-dialog uk-modal-body">
        <h2 class="uk-modal-title">Add address</h2>
        <form class="uk-margin" method="post" asp-page-handler="AddAddress" asp-antiforgery="true" data-ajax="true" data-ajax-method="post" data-ajax-success="addAddressSuccess" data-ajax-failure="addAddressFailed">
            <div class="uk-margin-small">
                <div>
                    <label asp-for="AddressFormData.Name" class="uk-form-label"></label>
                    <input asp-for="AddressFormData.Name" class="uk-input" type="text" maxlength="128" required>
                    <span asp-validation-for="AddressFormData.Name" class="uk-text-danger uk-text-small"></span>
                </div>
                <div>
                    <label asp-for="AddressFormData.Street" class="uk-form-label"></label>
                    <textarea asp-for="AddressFormData.Street" class="uk-textarea" rows="3" type="text" maxlength="128"></textarea>
                    <span asp-validation-for="AddressFormData.Street" class="uk-text-danger uk-text-small"></span>
                </div>
                <div class=" uk-grid-small" uk-grid>
                    <div class="uk-width-1-2@m">
                        <label asp-for="AddressFormData.PostalCode" class="uk-form-label"></label>
                        <input asp-for="AddressFormData.PostalCode" class="uk-input" type="text" placeholder="" maxlength="128" required>
                        <span asp-validation-for="AddressFormData.PostalCode" class="uk-text-danger uk-text-small"></span>
                    </div>
                    <div class="uk-width-1-2@m">
                        <label asp-for="AddressFormData.Country" class="uk-form-label"></label>
                        <input id="address-country-code" class="uk-input" type="text" readonly="readonly">
                        <input type="hidden" id="new-address-country-code" asp-for="AddressFormData.Country">
                        <span asp-validation-for="AddressFormData.Country" class="uk-text-danger uk-text-small"></span>
                    </div>
                </div>
            </div>
            <p class="uk-text-right">
                <button class="uk-button uk-button-primary" type="submit">Add Address</button>
                @if (Model.IsXHR)
                {
                    <a class="uk-button uk-button-default" href="#bng-modal" uk-toggle>Cancel</a>
                }
                else
                {
                    <button class="uk-button uk-button-default uk-modal-close" type="button">Cancel</button>
                }
            </p>
        </form>
    </div>
</div>
<!-- End of modal -->
<script>
    //Country
    $(document).ready(function () {
        selectedAddressCountry();
    });

     $("#address-country-code").countrySelect({
        defaultCountry: '@Model.MemberCountryCode.ToLower()',
        preferredCountries: ["au", "ca", "hk", "jp", "my", "ph", "qa", "sa", "sg", "tw", "ae", "us", "gb"],
    });

    function selectedAddressCountry() {
        var country_code = $("#address-country-code").countrySelect("getSelectedCountryData");
        $("#new-address-country-code").val(country_code.iso2.toUpperCase());
    }

    $("#address-country-code").change(function () {
        selectedAddressCountry();
    });


    //
    $('.member-address-resend-verification').click(function () {
        $('.member-address-resend-verification-input').val($(this).attr('memberAddressSid'));
    });
    $('.member-address-remove').click(function () {
        $('.member-address-remove-input').val($(this).attr('memberAddressSid'));
        $('.modal-address').html($(this).attr('memberAddress'));
    });


    // Add Address
    addAddressSuccess = (xhr) => {
        location.reload();
        showSuccessNotification(xhr);
    };
    addAddressFailed = (xhr) => {
        UIkit.modal("#bng-modal").show();
        showErrorNotification(xhr.responseText);
    };

    // Remove Address
    removeAddressSuccess = (xhr) => {
        $("#modal-address-remove").remove();
        UIkit.modal("#bng-modal").hide();
        showSuccessNotification(xhr);
    };
    removeAddressFailed = (xhr) => {
        UIkit.modal("#bng-modal").show();
        showErrorNotification(xhr.responseText);
    };

    // Make Primary Address
    makePrimaryAddressSuccess = (xhr) => {
        location.reload();
        showSuccessNotification(xhr);
    };
    makePrimaryAddressFailed = (xhr) => {
        UIkit.modal("#bng-modal").show();
        showErrorNotification(xhr.responseText);
    };
</script>